#include "StdAfx.h"
#include "NtalkPacketHeader.h"

CNTalkPacketHeader::CNTalkPacketHeader(void)
{
}

CNTalkPacketHeader::~CNTalkPacketHeader(void)
{
}


int CNTalkPacketHeader::MakeHeader(WORD wCmdCode, int nBodyLen, char** buff)
{
	int nHeaderLen = 0;

	PACKET_HEADER header;
	header.wMagicCode = MAGIC_CODE;
	header.wHeaderLength = PACKET_HEADER_LEN;
	header.wCmdCode = wCmdCode;
	header.ucVer = 0;
	header.ucEncryptType = 0;
	header.unTransactionID = 0;
	header.wSessionID = 0;
	header.wBodyLength = 0;

	header.wBodyLength = nBodyLen;
	memcpy(*buff, &header.wMagicCode, 2);
	nHeaderLen += 2;

	memcpy((*buff) + nHeaderLen, &header.wHeaderLength, 2);
	nHeaderLen += 2;

	memcpy((*buff) + nHeaderLen, &header.wCmdCode, 2);
	nHeaderLen += 2;

	memcpy((*buff) + nHeaderLen, &header.ucVer, 1);
	nHeaderLen += 1;

	memcpy((*buff) + nHeaderLen, &header.ucEncryptType, 1);
	nHeaderLen += 1;

	memcpy((*buff) + nHeaderLen, &header.unTransactionID, 4);
	nHeaderLen += 4;

	memcpy((*buff) + nHeaderLen, &header.wSessionID, 2);
	nHeaderLen += 2;

	memcpy((*buff) + nHeaderLen, &header.wBodyLength, 2);
	nHeaderLen += 2;

	return header.wHeaderLength;

}